/***************************************************************************
 *   Copyright (C) 2004 by Heiko Schaefer                                  *
 *   heiko@rangun.de                                                       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#ifndef WMFTHUMBCREATOR_H
#define WMFTHUMBCREATOR_H

#include <libwmf/api.h>
#include <libwmf/gd.h>
#include <math.h>
#include <qvaluevector.h>

#include <kio/thumbcreator.h>

/**
@author Heiko Schaefer

$Id: wmfthumbcreator.h,v 1.2 2004/03/18 15:33:19 zxmpl18 Exp $

$Log: wmfthumbcreator.h,v $
Revision 1.2  2004/03/18 15:33:19  zxmpl18
* Adaptions to make it more KDE-conform


*/

/// The WMF-Scalefactor (the lower the faster)
#define SCALE 1.0

/// The average png image size
#define AVGIMGSIZE 30720

class WMFThumbCreator : public ThumbCreator
{

	WMFThumbCreator(const WMFThumbCreator&);
	WMFThumbCreator& operator=(const WMFThumbCreator&);
	
    static int sink(void * context, char * buffer, int length);

public:
    WMFThumbCreator();
    ~WMFThumbCreator();
	
    virtual bool create(const QString &path, int width, int height, QImage &img);

    /*!
        \fn WMFThumbCreator::flags() const
     */
    virtual ThumbCreator::Flags flags() const
    {
        return None; // try BlendIcon as an alternative
    }

private:

    static QValueVector<char> m_imageData;
	static unsigned long      m_flags;
	
    wmfAPI_Options m_options;
    wmfAPI   *     m_API;
    wmf_gd_t *     m_ddata;
};

#endif
